<?
sapp_include_once('common.php');

/**
* Checks the validity of the current form.
*
* @return integer
*/

function form_handler()
{
	
	$valid_required = true;
	$valid_optional = true;
	$valid = true;

	/*******************************
	 *
	 *	Required parameters
	 *
	 *******************************/

        //check db name
        $gallery2_dbname = sapp_get_submit_value('gallery2_dbname');
        if (!check_dbName($gallery2_dbname)) {
                sapp_set_wrong('gallery2_dbname', msg('invalid_value'));
                $valid = false;
        }

        sapp_set_param('gallery2_dbname', $gallery2_dbname);

        if (sapp_is_database_exists($gallery2_dbname, 'mysql')) {
                sapp_set_wrong('gallery2_dbname', msg('db__database_already_exists'));
                $valid = false;
        }

        //check db user
        $gallery2_dbuser = sapp_get_submit_value('gallery2_dbuser');
        if (!check_dbUserName($gallery2_dbuser)) {
                sapp_set_wrong('gallery2_dbuser', msg('invalid_value'));
                $valid = false;
        }

        sapp_set_param('gallery2_dbuser', $gallery2_dbuser);

        //check db passwd
        $gallery2_dbpasswd = sapp_get_submit_value('gallery2_dbpasswd');
        $gallery2_dbconfirm = sapp_get_submit_value('gallery2_dbconfirm');
        if ('' == $gallery2_dbpasswd) {
                if (!sapp_get_param('gallery2_dbpasswd')) {
                        sapp_set_wrong('gallery2_dbpasswd', msg('password__empty'));
                        $valid = false;
                } else {
                        $gallery2_dbpasswd = sapp_get_param('gallery2_dbpasswd');
                }
        } elseif ($gallery2_dbpasswd != $gallery2_dbconfirm) {
                sapp_set_wrong('gallery2_dbpasswd', msg('password__not_match'));
                sapp_set_wrong('gallery2_dbconfirm', msg('password__not_match'));
                $valid = false;
        } else {
                sapp_set_param('gallery2_dbpasswd', $gallery2_dbpasswd);
        }

        if (sapp_is_database_user_exists($gallery2_dbname, 'mysql', $gallery2_dbuser, $gallery2_dbpasswd)) {
                sapp_set_wrong('gallery2_dbuser', msg('db__database_user_already_exists'));
                $valid = false;
        }

        if (!$valid) {
                sapp_set_warning(msg('invalid_values'));
                return 1;
        }

        if (!sapp_create_database($gallery2_dbname, 'mysql')) {
                sapp_set_wrong('gallery2_dbname', msg('db__unable_to_create'));
                return 1;
        }

        if (!sapp_create_database_user($gallery2_dbname, 'mysql', $gallery2_dbuser, $gallery2_dbpasswd)) {
                sapp_set_wrong('gallery2_dbuser', msg('db__unable_to_create'));
                return 1;
        }



	// check install_prefix separately, as it requires special validity check
	$install_prefix = sapp_get_submit_value('install_prefix');
	if (null === $install_prefix) {
		sapp_set_warning(msg('you_should_specify_installation_directory'));
		sapp_set_wrong('install_prefix');
	} elseif (SITEAPP_DIR_NOT_EXISTS !== ($ret = sapp_set_install_prefix($install_prefix))) {

		sapp_set_wrong('install_prefix');

		switch ($ret) {

			case SITEAPP_DIR_INVALID_NAME:
				sapp_set_warning(msg('installation_directory_name_isn_t_valid'));
				break;

			case SITEAPP_DIR_USED_BY_UNKNOWN:
				sapp_set_warning(msg('installation_directory_already_exists'));
				break;

			case SITEAPP_DIR_USED_BY_SITEAPP:
				sapp_set_warning(msg('installation_directory_is_used_by_other_site_application'));
				break;
		}
	}

	if (sapp_is_ssl_avaible())
		$valid_required &= check_and_set_required('ssl_target_directory');

	$valid_required &= check_and_set_required('admin_login', 'check_sys_login');
	$valid_required &= check_and_set_required('admin_email', 'check_email');
	//check admin password
	$gal_admin_passwd = sapp_get_submit_value('admin_passwd');
	$gal_admin_confirm = sapp_get_submit_value('admin_confirm');
	if ('' == $gal_admin_passwd) {
		if (!sapp_get_param('admin_passwd')) {
			sapp_set_wrong('admin_passwd', msg('password__empty'));
			$valid_required = false;
		} else {
			$gal_admin_passwd = sapp_get_param('admin_passwd');
		}
	} elseif ($gal_admin_passwd != $gal_admin_confirm) {
		sapp_set_wrong('admin_passwd', msg('password__not_match'));
		sapp_set_wrong('admin_confirm', msg('password__not_match'));
		$valid_required = false;
	} elseif (!check_sys_passwd(sapp_get_param('admin_login'), $gal_admin_passwd)) {
		sapp_set_wrong('admin_passwd', msg('invalid_value'));
		$valid_required = false;
	} else {
	    $valid_required &= check_and_set_required('admin_passwd');
	}

	$salt = '';
	for ($i = 0; $i < 4; $i++) {
		$char = mt_rand(48, 109);
		$char += ($char > 90) ? 13 : ($char > 57) ? 7 : 0;
		$salt .= chr($char);
	}
	$admin_hash = $salt . md5($salt . $gal_admin_passwd);
	sapp_set_param("admin_hash", $admin_hash);

	$rand_pass = '';
	for ($i=0; $i<8; $i++){
		$rand_pass .= mt_rand(48, 109);
	}
	sapp_set_param("setup_admin_pass", $rand_pass);

	if (!$valid_required)
		sapp_set_warning('Not all required parameters are correctly specifyed');
			
	$valid_optional &= check_and_set_optional('gallery_name');
	$valid_optional &= check_and_set_optional('admin_fullname');
	$valid_optional &= check_and_set_optional('locale');

	if (!$valid_optional)
		sapp_set_warning('Optional parameters are wrong');
		
	if (!$valid_optional || !$valid_required)
		return 1;
		
	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}

?>
